﻿using HeuristicLab.Core;
using HeuristicLab.Common;
using HEAL.Attic;

namespace HeuristicLab.Problems.MetaOptimization {
  // todo: item name/descr...
  [StorableType("57D6671C-52A3-4DA5-8CD1-6BFD09B5F29E")]
  public class ParameterConfigurationOnePositionsManipulator : ParameterConfigurationManipulator {

    public ParameterConfigurationOnePositionsManipulator() { }
    [StorableConstructor]
    protected ParameterConfigurationOnePositionsManipulator(StorableConstructorFlag _) : base(_) { }
    protected ParameterConfigurationOnePositionsManipulator(ParameterConfigurationOnePositionsManipulator original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new ParameterConfigurationOnePositionsManipulator(this, cloner);
    }

    public sealed override IOperation Apply() {
      Apply(RandomParameter.ActualValue, ParameterConfigurationTreeParameter.ActualValue, IntValueManipulatorParameter.ActualValue, DoubleValueManipulatorParameter.ActualValue);
      return base.Apply();
    }

    public static void Apply(IRandom random, ParameterConfigurationTree configuration, IIntValueManipulator intValueManipulator, IDoubleValueManipulator doubleValueManipulator) {
      IOptimizable optimizable = configuration.GetRandomOptimizable(random);
      Mutate(random, optimizable, intValueManipulator, doubleValueManipulator);
    }
  }
}